﻿using System;
using System.Web.Mvc;
using System.Web.Mvc.BindingHelpers;
using MvcApplication.Models;
using HaackMvcHelpers;

namespace MvcApplication.Controllers
{
    public class ArticleController : Controller
    {
        IArticleRepository repository;

        //Use this until we set up DI
        public ArticleController() : this(new InMemoryArticleRepository())
        { }

        //Use this if we set up DI
        public ArticleController(IArticleRepository repository)
        {
            this.repository = repository;
        }

        [ControllerAction]
        public void New()
        {
            RenderView("New");
        }

        [ControllerAction]
        public void Create()
        {
            Article article = new Article();
            article.Populate(Request.Form);

            if (!article.IsValid)
            {
                TempData.PopulateFrom(article);
                TempData["Message"] = "Title and Body may not be empty!";
                RedirectToAction("New");  
            }
            else
            {
                this.repository.Persist(article);
                RedirectToAction("List"); 
            }
        }

        [ControllerAction]
        public void List()
        {
            RenderView("List", this.repository.GetArticles());
        }
    }
}
